"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Queue = function () {
  function Queue() {
    _classCallCheck(this, Queue);

    this.items = [];
  }

  /**
   * Add an item to the queue
   * @method enqueue
   * @param {Object} item - item to be queued
   * @return {Void}
   */


  _createClass(Queue, [{
    key: "enqueue",
    value: function enqueue(element) {
      this.items.push(element);
    }

    /**
     * Remove the first a item of the queue, and return it
     * @method dequeue
     * @return {Object} the first item in the queue
     */

  }, {
    key: "dequeue",
    value: function dequeue() {
      return this.items.shift();
    }

    /**
     * Return the first a item of the queue
     * @method front
     * @return {Object} the first item in the queue
     */

  }, {
    key: "front",
    value: function front() {
      return this.isEmpty() ? null : this.items[0];
    }

    /**
     * Check if the queue is empty
     * @method isEmpty
     * @return {Boolean} if the queue is empty or not
     */

  }, {
    key: "isEmpty",
    value: function isEmpty() {
      return this.items.length === 0;
    }

    /**
     * Remove all items in the queue
     * @method clear
     * @return {Void}
     */

  }, {
    key: "clear",
    value: function clear() {
      this.items = [];
    }

    /**
     * Get the size of the queue
     * @method size
     * @return {Number} the size of the queue
     */

  }, {
    key: "size",
    value: function size() {
      return this.items.length;
    }

    /**
     * Get the queue item in string format
     * @method toString
     * @return {String} The string value of the queue
     */

  }, {
    key: "toString",
    value: function toString() {
      return JSON.stringify(this.items);
    }
  }]);

  return Queue;
}();

exports.default = Queue;